LeetCode 加油站

在一条环路上有 N 个加油站,其中第 i 个加油站有汽油 gas[i] 升。
你有一辆油箱容量无限的的汽车,从第 i 个加油站开往第 i+1 个加油站需要消耗汽油 cost[i] 升。你从其中的一个加油站出发,开始时油箱为空。
如果你可以绕环路行驶一周,则返回出发时加油站的编号,否则返回 -1。

说明:

如果题目有解,该答案即为唯一答案。
输入数组均为非空数组,且长度相同。
输入数组中的元素均为非负数。

示例 1:

输入: 
gas  = [1,2,3,4,5]
cost = [3,4,5,1,2]
输出: 3
解释:
从 3 号加油站(索引为 3 处)出发,可获得 4 升汽油。此时油箱有 = 0 + 4 = 4 升汽油
开往 4 号加油站,此时油箱有 4 - 1 + 5 = 8 升汽油
开往 0 号加油站,此时油箱有 8 - 2 + 1 = 7 升汽油
开往 1 号加油站,此时油箱有 7 - 3 + 2 = 6 升汽油
开往 2 号加油站,此时油箱有 6 - 4 + 3 = 5 升汽油
开往 3 号加油站,你需要消耗 5 升汽油,正好足够你返回到 3 号加油站。
因此,3 可为起始索引。

示例 2:

输入: 
gas  = [2,3,4]
cost = [3,4,3]
输出: -1
解释:
你不能从 0 号或 1 号加油站出发,因为没有足够的汽油可以让你行驶到下一个加油站。
我们从 2 号加油站出发,可以获得 4 升汽油。 此时油箱有 = 0 + 4 = 4 升汽油
开往 0 号加油站,此时油箱有 4 - 3 + 2 = 3 升汽油
开往 1 号加油站,此时油箱有 3 - 3 + 3 = 3 升汽油
你无法返回 2 号加油站,因为返程需要消耗 4 升汽油,但是你的油箱只有 3 升汽油。
因此,无论怎样,你都不可能绕环路行驶一周。

思路分析:采取回溯法。最开始选择出发点,如果在当前节点剩余的油能够走到下一个节点,就继续往下走,直到回到出发点,否则改变出发点,继续寻找。

class Solution {
public:
	int result = -1;
	int canCompleteCircuit(vector<int>& gas, vector<int>& cost) {
		int vecSize = gas.size();
		//选择出发点(不包括最后一个点)
		for (int i = 0; i < vecSize - 1; ++i) {
			if (gas[i] >= cost[i] && dfs(gas, cost, i, i + 1, gas[i] - cost[i])) {
				return result;
			}
		}
        //单独最后一个点作为出发点,因为最后一个点出发点的下一个点是下标0
		if (gas[vecSize - 1] >= cost[vecSize - 1]) {
			dfs(gas, cost, vecSize - 1, 0, gas[vecSize - 1] - cost[vecSize - 1]);
		}
		return result;
	}
	//beginIndex是出发点, nowIndex现在的下标, remainGas走到nowIndex剩余的汽油, 现在剩余的汽油需要加上gas[nowIndex]
	bool dfs(vector<int>& gas, vector<int>& cost, int beginIndex, int nowIndex, int remainGas) {
		if (beginIndex == nowIndex) {//如果回到的出发点
			result = beginIndex;
			return true;
		}
		int vecSize = gas.size();
		if (remainGas + gas[nowIndex] >= cost[nowIndex]) {//判断能否继续往下走
			if (nowIndex == vecSize - 1) {//如果现在处于尾端,下一个位置是0
				return dfs(gas, cost, beginIndex, 0, remainGas - cost[nowIndex] + gas[nowIndex]);
			}
			else {//否则直接移动到下一个下标
				return dfs(gas, cost, beginIndex, nowIndex + 1, remainGas - cost[nowIndex] + gas[nowIndex]);
			}
		}
		return false;
	}
};

在这里插入图片描述
方法二:递推法。穷举出发点,直接递推往下走

class Solution {
public:
	int canCompleteCircuit(vector<int>& gas, vector<int>& cost) {
		int vecSize = gas.size();
		int remainGas;
		//选择出发点
		for (int begin = 0; begin < vecSize; ++begin) {
			int nowIndex = begin;
			//如果这个点能够出发
			if (gas[begin] < cost[begin]) {
				continue;
			}
			//出发
			remainGas = gas[begin] - cost[begin];
			nowIndex = (nowIndex + 1) % vecSize;//循环后移
			//如果能够往下走
			while (gas[nowIndex] + remainGas >= cost[nowIndex] && nowIndex != begin) {
				remainGas += gas[nowIndex] - cost[nowIndex];//更新剩余的油
				nowIndex = (nowIndex + 1) % vecSize;//循环后移
			}
			if (nowIndex == begin) {
				return begin;
			}
		}
		return -1;
	}
};

在这里插入图片描述

猜你喜欢

转载自blog.csdn.net/qq_41855420/article/details/87888896